﻿using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using System.Linq; 

namespace JayJayWon
{
    public class NodeAlign : MVRScript
    {
        const string pluginName = "NodeAlign";
		const string pluginAuthor = "JayJayWon";
        const string pluginVersion = "v1.1";

		public override void Init() {
			try {			
			
				_orificeFemaleChoices = new List<string>();
				_orificeFemaleChoices.Add( "Mouth");
				_orificeFemaleChoices.Add("Vagina");
				_orificeFemaleChoices.Add("Anus");
				
				_orificeMaleChoices = new List<string>();
				_orificeMaleChoices.Add( "Mouth");
				_orificeMaleChoices.Add("Anus");

                // make atom selector
                _atom1JSON = new JSONStorableStringChooser("atom1", SuperController.singleton.GetAtomUIDs(), null, "Atom", SyncAtom1);
                _atom1JSON.storeType = JSONStorableParam.StoreType.Physical;
                RegisterStringChooser(_atom1JSON);
                SyncAtom1Choices();
                _displayPopup = CreateScrollablePopup(_atom1JSON);
                _displayPopup.popupPanelHeight = 1100f;
                // want to always resync the atom choices on opening popup since atoms can be added/removed
                _displayPopup.popup.onOpenPopupHandlers = SyncAtom1Choices;
                _displayPopup.label = "Target Person";

                // make receiver selector
                _receiver1JSON = new JSONStorableStringChooser("receiver1", null, null, "Receiver", SyncReceiver1);
                _receiver1JSON.storeType = JSONStorableParam.StoreType.Physical;
                RegisterStringChooser(_receiver1JSON);
                _displayPopup = CreateScrollablePopup(_receiver1JSON);
                _displayPopup.popupPanelHeight = 990f;
                // want to always resync the receivers, since plugins can be added/removed
                _displayPopup.popup.onOpenPopupHandlers += SyncReceiver1Choices;
                _displayPopup.label = "Target Node";

                var spacer = CreateSpacer();
                spacer.height = 10;
			

				if (_atom1JSON == null)
				{
					SyncAtom1("");
				}
				else
				{
					SyncAtom1(_atom1JSON.val);
				}

                var btn = CreateButton("Execute",false);
                btn.button.onClick.AddListener(() =>
                {
                    ExecuteAction();
                });
				JSONStorableAction _executeAction = new JSONStorableAction("Execute", () =>{ExecuteAction();});
                RegisterAction(_executeAction);
				
				_holdAlignment = new JSONStorableBool ("holdNodeAlign",false);
				RegisterBool(_holdAlignment);
				var toggle = CreateToggle(_holdAlignment);
                toggle.label = "Hold Node Alignment";

                		
                spacer = CreateSpacer();
                spacer.height = 250;

				JSONStorableString pluginVersionJSON = new JSONStorableString("PluginVersion","");
				UIDynamicTextField dtext = CreateTextField(pluginVersionJSON,false);
				pluginVersionJSON.val = pluginName +" "+pluginVersion + "\n by "+pluginAuthor;
				dtext.height = 1;
   
                // make atom selector
                _offsetAtomJSON = new JSONStorableStringChooser("offsetAtom", SuperController.singleton.GetAtomUIDs(), null, "Person", SyncOffsetAtom);
                _offsetAtomJSON.storeType = JSONStorableParam.StoreType.Physical;
                RegisterStringChooser(_offsetAtomJSON);
                SyncOffsetAtomChoices();
//                _displayPopup = CreateScrollablePopup(_offsetAtomJSON,true);
//                _displayPopup.popupPanelHeight = 1100f;
                // want to always resync the atom choices on opening popup since atoms can be added/removed
//                _displayPopup.popup.onOpenPopupHandlers = SyncOffsetAtomChoices;
//                _displayPopup.label = "Person";

                // make Orifice receiver selector
                _offsetOrificeJSON = new JSONStorableStringChooser("offsetOrifice", null, "Mouth", "Orifice", SyncOrifice);
                _offsetOrificeJSON.storeType = JSONStorableParam.StoreType.Physical;
                RegisterStringChooser(_offsetOrificeJSON);
//                _displayPopup = CreateScrollablePopup(_offsetOrificeJSON,true);
//                _displayPopup.popupPanelHeight = 990f;
                // want to always resync the receivers, since plugins can be added/removed
 //               _displayPopup.popup.onOpenPopupHandlers += SyncOffsetOrificeChoices;
 //               _displayPopup.label = "Orifice";

				_isMale = false ;
				_offsetOrificeJSON.choices = _orificeFemaleChoices ;


                // make Control Node selector
                _offsetControlNodeJSON = new JSONStorableStringChooser("offsetOrificeContol", null, "LipTrigger", "OrificeControl", SyncOrificeControl);
                _offsetControlNodeJSON.storeType = JSONStorableParam.StoreType.Physical;
                RegisterStringChooser(_offsetControlNodeJSON);
 //               _displayPopup = CreateScrollablePopup(_offsetControlNodeJSON,true);
 //               _displayPopup.popupPanelHeight = 990f;
                // want to always resync the receivers, since plugins can be added/removed
 //               _displayPopup.popup.onOpenPopupHandlers += SyncOrificeControlNodeChoices;
//                _displayPopup.label = "Orifice Control Node";

				if (_offsetAtomJSON == null)
				{
					SyncOffsetAtom("");
				}
				else
				{
					SyncOffsetAtom(_offsetAtomJSON.val);
				}


				SuperController.singleton.onAtomUIDRenameHandlers += new SuperController.OnAtomUIDRename(this.AtomNameUpdate);
 			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		protected bool CheckMaleGender (Atom atom)
		{
			if (atom == null)
			{
				return false ;
			}
			else
			{
				bool charName = atom.GetComponentInChildren<DAZCharacter>().name.StartsWith("male");
				if (charName )
				{
					return true ;
				}
				else
				{
					return false ;
				}
			}
		}

		protected void UpdateOrificeChoices ()
		{
			if (_offsetAtom != null && _offsetOrificeJSON !=null)
			{
				if (!_isMale && CheckMaleGender (_offsetAtom) )
				{
					_isMale = true;
					_offsetOrificeJSON.choices = _orificeMaleChoices ;					
					if (_offsetOrificeJSON.val == "Vagina") 
					{
						_offsetOrificeJSON.val = "Anus";
					}				
				}
				else if (_isMale && !CheckMaleGender (_offsetAtom))
				{
					_isMale = false;
					_offsetOrificeJSON.choices = _orificeFemaleChoices ;
				}			
			}
		}


		protected void ExecuteAction()
		{
			try {
				Vector3 orificePosition = new Vector3();

				if(_atom1!=null)
				{
					Rigidbody rb = _atom1.rigidbodies.First(rigidb => rigidb.name == _receiver1JSON.val);
					_offsetControlNode = _offsetAtom.rigidbodies.First(rigidb => rigidb.name == _offsetControlNodeJSON.val);
					
						if (_offsetOrificeJSON.val == "Mouth")
						{
							orificePosition = _lipTrigger.transform.position ;
//							targetUpDirection = _lipTrigger.transform.up ;
						}
						if (_offsetOrificeJSON.val == "Vagina")
						{
							orificePosition = _labiaTrigger.transform.position ;
						}
/*						if (_offsetOrificeJSON.val == "Anus")
						{
							anusTransform = _thisControl.transform ;
							tempPosition = anusTransform.position ;
							tempRotation = anusTransform.rotation ;
							
							anusTransform.position = _labiaTrigger.transform.position ;
							anusTransform.rotation = Quaternion.LookRotation (_labiaTrigger.transform.position - _vaginaTrigger.transform.position,_labiaTrigger.transform.up) ;
							
							if (!_isMale)
							{
								anusOffsetPosition = new Vector3 (0.0f,-0.025f,-0.0015f);
							}
							else
							{
								anusOffsetPosition = new Vector3 (0.0f,-0.025f,0.008f);
							}
							anusTransform.Translate (anusOffsetPosition, anusTransform) ;
							
							targetPosition = anusTransform.position;
							targetUpDirection = anusTransform.up ;
							targetRotation = Quaternion.LookRotation (_vaginaTrigger.transform.position - anusTransform.position, targetUpDirection) ;
							targetRotationInverse = Quaternion.LookRotation (anusTransform.position - _vaginaTrigger.transform.position, targetUpDirection) ;
							
							anusTransform.position = tempPosition ;
							anusTransform.rotation = tempRotation ;
						}
*/					
					
					
					if (rb!= null)
					{
//						containingAtom.freeControllers.First(freec => freec.name == "control").transform.position = rb.transform.position + (_offsetControlNode.transform.position - orificePosition);
						containingAtom.freeControllers.First(freec => freec.name == "control").transform.position = rb.transform.position ;
						
						containingAtom.freeControllers.First(freec => freec.name == "control").transform.rotation = rb.transform.rotation;
					}
				}
				else {SuperController.LogMessage("atom is null");}
							
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

        protected void SyncAtom1Choices()
        {
            _atom1JSON.choices = GetPersonListChoices ();
        }

        protected List<string> GetPersonListChoices()
        {
            List<string> atomChoices = new List<string>();
            foreach (string atomUID in SuperController.singleton.GetAtomUIDs())
            {
				Atom atom = SuperController.singleton.GetAtomByUid (atomUID);
				if (atom.type == "Person")
				{
					atomChoices.Add(atomUID);
				}
            }
			return atomChoices;
		}

       // receiver Atom
        protected void SyncAtom1(string atomUID)
        {
			List<string> choices = new List<string>();
			if (atomUID == null)
			{
				atomUID="";
			}
			SyncAtom1Choices();
			if (_atom1JSON.choices.Count > 0)
			{
				if (atomUID == "" || !_atom1JSON.choices.Contains(atomUID))
				{
					_atom1JSON.val = _atom1JSON.choices[0];
					atomUID = _atom1JSON.val;
				}
            }
			
			_atom1 = SuperController.singleton.GetAtomByUid(atomUID);
			choices = GetNodeReceiverListChoices (atomUID);
			
			if (_receiver1JSON != null)
			{
				_receiver1JSON.choices = choices;
				if (!_receiver1JSON.choices.Contains(_receiver1JSON.val))
				{
					if (_receiver1JSON.choices.Count > 0)
					{
						_receiver1JSON.val = _receiver1JSON.choices[0];
					}
				}
			}
        }
		


 		protected List<string> GetNodeReceiverListChoices(string atomUID)
		{
            List<string> receiverChoices = new List<string>();
			if (atomUID!="")
			{
				Atom atom = SuperController.singleton.GetAtomByUid(atomUID);
				foreach (Rigidbody rb in atom.rigidbodies)
				{
					if (!rb.name.Contains("Collider") && !rb.name.Contains("_") && !rb.name.Contains("Ponytail") && !rb.name.Contains("Link")){
					receiverChoices.Add(rb.name);}
				}
			}
			else {receiverChoices.Add("Empty");}
			return receiverChoices ;
		}
				
        protected void SyncReceiver1Choices()
        {
			SyncAtom1 (_atom1JSON.val);
        }

       // receiver JSONStorable
        protected void SyncReceiver1(string receiverID)
        {			
			if (_atom1 != null && receiverID !=null)
			{
                _receiver1 = _atom1.GetStorableByID(receiverID);
            }
            else
            {
                _receiver1 = null;
            }
		}	

		protected void SyncOffsetAtom (string atomUID)
		{
			List<string> choices = new List<string>();
			if (atomUID == null){
				atomUID="";
			}
			SyncOffsetAtomChoices();
			if (_offsetAtomJSON.choices.Count > 0)
			{
				if (atomUID == "" || !_offsetAtomJSON.choices.Contains(atomUID))
				{
					_offsetAtomJSON.val = _offsetAtomJSON.choices[0];
					atomUID = _offsetAtomJSON.val;
				}
            }
			
			_offsetAtom = SuperController.singleton.GetAtomByUid(atomUID);
			choices = GetNodeReceiverListChoices (atomUID);
	
			if (_offsetControlNodeJSON != null)
			{
				_offsetControlNodeJSON.choices = choices;
				if (!_offsetControlNodeJSON.choices.Contains(_offsetControlNodeJSON.val))
				{
					if (_offsetControlNodeJSON.choices.Count > 0)
					{
						_offsetControlNodeJSON.val = _offsetControlNodeJSON.choices[0];
					}
				}
			}
			
			UpdateOrificeChoices();
			if (!_offsetOrificeJSON.choices.Contains(_offsetOrificeJSON.val))
			{
				_offsetOrificeJSON.val = _offsetOrificeJSON.choices[0];
			}

			_lipTrigger = _offsetAtom.rigidbodies.First(rb => rb.name == "LipTrigger");
			_mouthTrigger = _offsetAtom.rigidbodies.First(rb => rb.name == "MouthTrigger");
			_labiaTrigger = _offsetAtom.rigidbodies.First(rb => rb.name == "LabiaTrigger");
			_vaginaTrigger = _offsetAtom.rigidbodies.First(rb => rb.name == "VaginaTrigger");
				
		}

		protected void SyncOrifice (string orificeUID)
		{
		}

		protected void SyncOrificeControl (string nodeUID)
		{
		}

        protected void SyncOffsetAtomChoices()
        {
            _offsetAtomJSON.choices = GetPersonListChoices ();			
		}

        protected void SyncOffsetOrificeChoices()
        {
			UpdateOrificeChoices ();
		}

        protected void SyncOrificeControlNodeChoices()
        {
		}

		protected void AtomNameUpdate(string oldName, string newName){
			try{
				if (_atom1JSON.val == oldName){_atom1JSON.val = newName;}
			}
			catch (Exception e) {SuperController.LogError("Exception caught: " + e);}
		}


		// Start is called once before Update or FixedUpdate is called and after Init()
		void Start() {
			try {
				// put code in here
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		// Update is called with each rendered frame by Unity
		void Update() {
			try {
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		// FixedUpdate is called with each physics simulation frame by Unity
		void FixedUpdate() {
			try {
				if (_holdAlignment != null && !SuperController.singleton.isLoading)
				{
					if (_holdAlignment.val)
					{
						UpdateOrificeChoices ();
						ExecuteAction();
					}
				}
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		protected Atom _atom1;
        protected JSONStorable _receiver1;
		protected Atom _offsetAtom;
        protected Rigidbody _offsetControlNode;
//		protected JSONStorable _offsetOrifice;
		
        protected JSONStorableStringChooser _atom1JSON;
        protected JSONStorableStringChooser _receiver1JSON;

        protected JSONStorableStringChooser _offsetAtomJSON;
        protected JSONStorableStringChooser _offsetControlNodeJSON;
		protected JSONStorableStringChooser _offsetOrificeJSON;
		
		protected JSONStorableBool _holdAlignment ;
						
		protected List<String> _orificeMaleChoices;
		protected List<String> _orificeFemaleChoices;
		protected bool _isMale ;
		
		private Rigidbody _lipTrigger;
		private Rigidbody _mouthTrigger;
		private Rigidbody _labiaTrigger;
		private Rigidbody _vaginaTrigger;		

        protected UIDynamicPopup _displayPopup; // any UI element, just to check if visible
	}
}